/*
 * Copyright (C) 2009 Josh Ventura
 * 
 * This file is part of the Ultimate Doukutsu Trainer.
 * 
 * The trainer is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This trainer is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this trainer.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <windows.h>
#include <windowsx.h>
#include <iostream.h>
#include <Psapi.h>
#include <string>
#include <sstream>
using namespace std;

//Window
HWND hwnd; 
//process to hack
HANDLE proc = NULL;
//Two more handles to know
HWND itemdropdown,slotdropdown;

//Everything you'd want to edit
#include "basics.h"

/*  Declare Windows procedure  */
LRESULT CALLBACK WindowProcedure (HWND, UINT, WPARAM, LPARAM);


HWND weaponcb[weapon_count];
#define WIDGET_CB_INFHEALTH 1
#define WIDGET_CB_MAXHEALTH 2
#define WIDGET_CB_INFN8AMMO 3
#define WIDGET_CB_LOCKLEVEL 4
#define WIDGET_CB_NEEDNOAMMO 5
#define WIDGET_CB_INVINCIBLE 6
#define WIDGET_CB_INFBOOSTER 7
#define WIDGET_CB_NUMPADMOVE 8
#define WIDGET_CB_APPENDWPN 9
#define WIDGET_ITEM 10
#define WIDGET_SLOT 11
#define WIDGET_WEAPONCB_ROOT 12



/*  Make the class name into a global variable  */
char szClassName[ ] = "TrainerClass";

int WINAPI WinMain (HINSTANCE hThisInstance,
                     HINSTANCE hPrevInstance,
                     LPSTR lpszArgument,
                     int nCmdShow)
{              /* This is the handle for our window */
    MSG messages;            /* Here messages to the application are saved */
    WNDCLASSEX wincl;        /* Data structure for the windowclass */

    /* The Window structure */
    wincl.hInstance = hThisInstance;
    wincl.lpszClassName = szClassName;
    wincl.lpfnWndProc = WindowProcedure;      /* This function is called by windows */
    wincl.style = CS_DBLCLKS;                 /* Catch double-clicks */
    wincl.cbSize = sizeof (WNDCLASSEX);

    HICON micon=LoadIcon (hThisInstance,"mainicon");
    if (micon==NULL) micon=LoadIcon (NULL, IDI_APPLICATION);
    wincl.hIcon = micon;
    wincl.hIconSm = micon;
    wincl.hCursor = LoadCursor (NULL, IDC_ARROW);
    wincl.lpszMenuName = NULL;                 /* No menu */
    wincl.cbClsExtra = 0;                      /* No extra bytes after the window class */
    wincl.cbWndExtra = 0;                      /* structure or the window instance */
    
    HBRUSH gbgc=GetSysColorBrush(COLOR_BTNFACE);
    if (gbgc==NULL) gbgc=(HBRUSH)COLOR_BACKGROUND;
    wincl.hbrBackground = (HBRUSH) gbgc;

    /* Register the window class, and if it fails quit the program */
    if (!RegisterClassEx (&wincl))
    {
        MessageBox(NULL,"The program failed to initialize. The window class could not be registered.","Fail",MB_OK);
        return 0;
    }
    
    /* The class is registered, let's create the program*/
    hwnd = CreateWindowEx(0,szClassName,"Ultimate Doukutsu Trainer (v0.1) by Josh Ventura",WS_OVERLAPPEDWINDOW,CW_USEDEFAULT,CW_USEDEFAULT,650,480,HWND_DESKTOP,NULL,hThisInstance,NULL);
    
    // I'll grace you with an original comment at this point-- This is where we make the checkboxes
    int y=8;
    //First, health related ones
    CreateWindowEx(0,"button","Infinite Health",WS_VISIBLE|WS_CHILD|BS_CHECKBOX|BS_AUTOCHECKBOX,8,y,300,24,hwnd,(HMENU)WIDGET_CB_INFHEALTH,hThisInstance,NULL); y+=24;
    CreateWindowEx(0,"button","Max Health",WS_VISIBLE|WS_CHILD|BS_CHECKBOX|BS_AUTOCHECKBOX,8,y,300,24,hwnd,(HMENU)WIDGET_CB_MAXHEALTH,hThisInstance,NULL); y+=24;
    CreateWindowEx(0,"button","Invincible (intangible)",WS_VISIBLE|WS_CHILD|BS_CHECKBOX|BS_AUTOCHECKBOX,8,y,300,24,hwnd,(HMENU)WIDGET_CB_INVINCIBLE,hThisInstance,NULL); y+=24;
    CreateWindowEx(0,"button","Infinite Booster",WS_VISIBLE|WS_CHILD|BS_CHECKBOX|BS_AUTOCHECKBOX,8,y,250,24,hwnd,(HMENU)WIDGET_CB_INFBOOSTER,hThisInstance,NULL);
    CreateWindowEx(0,"button","Numpad Arrows Move",WS_VISIBLE|WS_CHILD|BS_CHECKBOX|BS_AUTOCHECKBOX,258,y,300,24,hwnd,(HMENU)WIDGET_CB_NUMPADMOVE,hThisInstance,NULL); y+=24;
    
    y+=16;
    CreateWindowEx(0,"static","For current weapon: (Still locks as you change weapon if left enabled)",WS_VISIBLE|WS_CHILD,8,y,630,24,hwnd,NULL,hThisInstance,NULL); y+=24;
      CreateWindowEx(0,"button","Infinite Ammo",WS_VISIBLE|WS_CHILD|BS_CHECKBOX|BS_AUTOCHECKBOX,24,y,300,24,hwnd,(HMENU)WIDGET_CB_INFN8AMMO,hThisInstance,NULL); y+=24;
      CreateWindowEx(0,"button","Gun Doesn't Need Ammo Anymore",WS_VISIBLE|WS_CHILD|BS_CHECKBOX|BS_AUTOCHECKBOX,24,y,300,24,hwnd,(HMENU)WIDGET_CB_NEEDNOAMMO,hThisInstance,NULL); y+=24;
      CreateWindowEx(0,"button","Lock Level (Numpad 1 and 3 change lock value)",WS_VISIBLE|WS_CHILD|BS_CHECKBOX|BS_AUTOCHECKBOX,24,y,500,24,hwnd,(HMENU)WIDGET_CB_LOCKLEVEL,hThisInstance,NULL); y+=24;
      
      y+=12; CreateWindowEx(0,"static","Iterate between these weapons: (Numpad + and - )",WS_VISIBLE|WS_CHILD,24,y,630,24,hwnd,NULL,hThisInstance,NULL); y+=16;
      
        y+=16;//Next, weapons
        for (int i=0;i<weapon_count;i++) //A checkbox for each button, automatically placed.
        weaponcb[i]=CreateWindowEx(0,"button",weapon_name[i],WS_VISIBLE|WS_CHILD|BS_CHECKBOX|BS_AUTOCHECKBOX,48+(i*150)%(150*4),y+(i/4)*28,148,24,hwnd,(HMENU)(WIDGET_WEAPONCB_ROOT+i),hThisInstance,NULL);
        y+=weapon_count/4*28; if (weapon_count%4 != 0) y+=28;
        y+=8;
      
      CreateWindowEx(0,"button","Numpad * Appends Polar Star to Inventory",WS_VISIBLE|WS_CHILD|BS_CHECKBOX|BS_AUTOCHECKBOX,24,y,360,24,hwnd,(HMENU)WIDGET_CB_APPENDWPN,hThisInstance,NULL); y+=24;
      y+=28;
    
    slotdropdown=CreateWindowEx(0,"combobox","",WS_VISIBLE|WS_CHILD|CBS_DROPDOWNLIST |CBS_SIMPLE,8,y,  150,240,hwnd,(HMENU)WIDGET_ITEM,hThisInstance,NULL);
    itemdropdown=CreateWindowEx(0,"combobox","",WS_VISIBLE|WS_CHILD|CBS_DROPDOWNLIST |CBS_SIMPLE,162,y,240,240,hwnd,(HMENU)WIDGET_SLOT,hThisInstance,NULL);
    
    //Add content to the dropdown boxes
    char addtext[30];
    for (int i=0;i<item_slot_count;i++) { sprintf(addtext,"Inventory Slot %d",i+1); ComboBox_AddString(slotdropdown,addtext); }
    for (unsigned int i=0;i<sizeof(item_name)/sizeof(char*);i++) { ComboBox_AddString(itemdropdown,item_name[i]); }
    
    
    /* Make the window visible on the screen */
    ShowWindow (hwnd, nCmdShow);
    
    cheat_init();
    
    DWORD *pids;
    pids=new DWORD[512];
    if (pids==0)
    {
        MessageBox(NULL,"Could not allocate enough memory to check process names. This shouldn't happen, I only wanted two kilobytes.","Fail",MB_OK);
        return -1;
    }
    DWORD szret;
    
    bool gp = EnumProcesses(pids,sizeof(int)*512,&szret);
    if (!gp)
    {
        MessageBox(NULL,"The system failed to fetch a list of processes. Could not locate Doukutsu.exe","Fail",MB_OK);
        return -2;
    }
    
    char getname[512];
    string cavestory="Doukutsu.exe";
    
    for (DWORD i=0;i<szret;i++)
    {
      cout << "Checking PID "<<i<<"...\r\n";
      proc=OpenProcess(PROCESS_QUERY_INFORMATION | PROCESS_VM_READ| PROCESS_VM_OPERATION  | PROCESS_VM_WRITE,1,pids[i]);
      if (proc!=NULL)
      {
        int ns=GetModuleFileNameEx(proc,NULL,getname,511);
        if (ns!=0)
        {
          getname[ns]=0;
          char *fnpart=getname+ns-1;
          while (fnpart>getname) { fnpart--; if (((*fnpart)=='\\') || ((*fnpart)=='/')) { fnpart++; break; } }
          cout << ">> "<<fnpart<<"\r\n";
          if (fnpart==cavestory) break;
        }
        CloseHandle(proc);
        proc=NULL;
      }
    }
    
    if (proc==NULL)
    {
      MessageBox(NULL,"Could not find Doukutsu's process.\r\nMake sure Cave Story is running, and that its name is Doukutsu.exe","Fail",MB_OK);
      return -3;
    }
    cout << "\r\n\r\n\r\nThis was a triumph, etc...\r\n";
    
    RegisterHotKey(hwnd,1,0,VK_ADD);
    RegisterHotKey(hwnd,2,0,VK_SUBTRACT);
    
    
    SetTimer(hwnd,1,100,(TIMERPROC)update_locks);
    
    /* Run the message loop. It will run until GetMessage() returns 0 */
    while (GetMessage (&messages, NULL, 0, 0))
    {
        /* Translate virtual-key messages into character messages */
        TranslateMessage(&messages);
        /* Send message to WindowProcedure */
        DispatchMessage(&messages);
    }

    /* The program return-value is 0 - The value that PostQuitMessage() gave */
    return messages.wParam;
}


/*  This function is called by the Windows function DispatchMessage()  */

LRESULT CALLBACK WindowProcedure (HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam)
{
    int wid;
    switch (message)                  /* handle the messages */
    {
        case WM_HOTKEY:
            switch (wParam)
            {
              case 1:
                cycle_weapon(1);
                break;
              case 2:
                cycle_weapon(-1);
                break;
              case 3:
                desired_level=3; 
                break;
              case 4:
                desired_level=1; 
                break;
              case 5:
                append_weapon(); 
                break;
              case 6: move(0,-32); break;
              case 7: move(-32,0); break;
              case 8: move(32,00); break;
              case 9: move(00,32); break;
            }
            break;
        case WM_COMMAND:
            if (HIWORD(wParam)==BN_CLICKED)
            {
              if (LOWORD(wParam)>=WIDGET_WEAPONCB_ROOT and LOWORD(wParam)<=(WIDGET_WEAPONCB_ROOT+weapon_count))
              {
                wid=LOWORD(wParam)-WIDGET_WEAPONCB_ROOT;
                weapon_queued[wid]=Button_GetCheck((HWND)lParam);
                cout << "Toggled '" << weapon_name[wid] << "' " << (Button_GetCheck((HWND)lParam)?"ON":"OFF") << " (" << wid << ")\r\n";
              }
              else if (LOWORD(wParam)==WIDGET_CB_MAXHEALTH) maxhealth=Button_GetCheck((HWND)lParam);
              else if (LOWORD(wParam)==WIDGET_CB_INFHEALTH) infhealth=Button_GetCheck((HWND)lParam);
              else if (LOWORD(wParam)==WIDGET_CB_INFN8AMMO) infammo=Button_GetCheck((HWND)lParam);
              else if (LOWORD(wParam)==WIDGET_CB_NEEDNOAMMO) neednoammo=Button_GetCheck((HWND)lParam);
              else if (LOWORD(wParam)==WIDGET_CB_INVINCIBLE) invincible=Button_GetCheck((HWND)lParam);
              else if (LOWORD(wParam)==WIDGET_CB_INFBOOSTER) infbooster=Button_GetCheck((HWND)lParam);
              else if (LOWORD(wParam)==WIDGET_CB_NUMPADMOVE)
              {
                numpadmove=Button_GetCheck((HWND)lParam);
                if (numpadmove)
                {
                  RegisterHotKey(hwnd,6,0,VK_NUMPAD8);
                  RegisterHotKey(hwnd,7,0,VK_NUMPAD4);
                  RegisterHotKey(hwnd,8,0,VK_NUMPAD6);
                  RegisterHotKey(hwnd,9,0,VK_NUMPAD2);
                }
                else
                {
                  UnregisterHotKey(hwnd,6);
                  UnregisterHotKey(hwnd,7);
                  UnregisterHotKey(hwnd,8);
                  UnregisterHotKey(hwnd,9);
                }
              }
              else if (LOWORD(wParam)==WIDGET_CB_LOCKLEVEL)
              {
                fixedlevel=Button_GetCheck((HWND)lParam); 
                if (fixedlevel) { RegisterHotKey(hwnd,3,0,VK_NUMPAD3); RegisterHotKey(hwnd,4,0,VK_NUMPAD1); }
                else            { UnregisterHotKey(hwnd,3); UnregisterHotKey(hwnd,4); }
              }
              else if (LOWORD(wParam)==WIDGET_CB_APPENDWPN)
              {
                appendweapon=Button_GetCheck((HWND)lParam);
                if (appendweapon) RegisterHotKey(hwnd,5,0,VK_MULTIPLY);
                else              UnregisterHotKey(hwnd,5);
              }
            }
            else if (LOWORD(wParam)==WIDGET_ITEM and HIWORD(wParam)==CBN_SELCHANGE)
            {
              ComboBox_SetCurSel(itemdropdown,get_inventory(ComboBox_GetCurSel(slotdropdown)));
            }
            else if (LOWORD(wParam)==WIDGET_SLOT and HIWORD(wParam)==CBN_SELCHANGE)
            {
              cout << "set slot "<<ComboBox_GetCurSel(slotdropdown) << " to "<<ComboBox_GetCurSel(itemdropdown);
              set_inventory(ComboBox_GetCurSel(slotdropdown),ComboBox_GetCurSel(itemdropdown));
            }
          break;
        case WM_DESTROY:
            PostQuitMessage (0);       /* send a WM_QUIT to the message queue */
            break;
        default:                      /* for messages that we don't deal with */
            return DefWindowProc (hwnd, message, wParam, lParam);
    }

    return 0;
}
